#include <stdio.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <signal.h>
#include <string.h>
#include <malloc.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <netdb.h>
#include <stdlib.h>
#include <rpc/rpc.h>
#include <netinet/ip.h>
#include <rpc/pmap_prot.h>
#include <rpc/pmap_clnt.h>
#include <sys/file.h>
#include <sys/uio.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <time.h>
#include <net/if.h>

#define MAXCHILD	55
#define SRC_PORT	53
#define PORTMAP_PORT	111
#define TIMEOUT		13

#define TH_FIN  0x01
#define TH_SYN  0x02
#define TH_RST  0x04
#define TH_ACK  0x10

/*
   struct iphdr{
   u_int8_t     ihl:4;
   u_int8_t     version:4;
   u_int8_t     tos;
   u_int16_t    tot_len;
   u_int16_t    id;
   u_int16_t    frag_off;
   u_int8_t     ttl;
   u_int8_t     protocol;
   u_int16_t    check;
   u_int32_t    saddr;
   u_int32_t    daddr;
   };
 */

struct tcphdr
  {
    u_int16_t th_sport;
    u_int16_t th_dport;
    u_int32_t th_seq;
    u_int32_t th_ack;
    u_int8_t th_x2:4;
    u_int8_t th_off:4;
    u_int8_t th_flags;
    u_int16_t th_win;
    u_int16_t th_sum;
    u_int16_t th_urp;
  };

struct pseudohdr
  {
    u_int32_t saddr;
    u_int32_t daddr;
    u_int8_t useless;
    u_int8_t protocol;
    u_int16_t tcplength;
  };

/** OS Defs **/
#define SOLARIS  1		/* Sol7(Intel),2.6,2.5,2.4(Sparc) */
#define SUNOS    2		/* SunOS4.1 (Sparc)               */
#define IRIX5    3		/* IRIX 5.3(Indy),6.3(O2)         */
#define IRIX6    4		/* IRIX 6.2(IMPACT)               */
#define LINUXOS  5		/* TurboLinux3.0 (Intel)          */
#define FBSD     6		/* FreeBSD 2.2.7 or NetBSD 1.3    */
#define DIGITAL  7		/* Digital 4.0 or HP-UX B1.10.20  */
#define WINDOWS  8		/* Windows 95/98/NT4              */
#define MACOS    9		/* MacOS 7.5.5 , 8.5              */
#define AIX3     10		/* AIX 3                          */
#define AIX4     11		/* AIX 4.1                        */
#define BSDOS    12		/* BSDI BSD/OS 2.1, 3.0           */
#define HPUX     13		/* HP-UX 9                        */
#define LINUX21  14		/* Linux 2.1.122 - 2.1.130        */
#define NETWARE  15		/* Novell Netware 3.12 - 5.00     */
#define OPENBSD  16		/* OpenBSD 2.1-2.3 or WinNT5 Beta */
#define SOLARIS2 17		/* Solaris2.3-2.5                 */
#define SOLARIS3 18		/* Solaris2.6-2.7                 */


/** rpc program #s **/
#define         RSTATD          100001
#define         NFSD            100003
#define         YPSERV          100004
#define         MOUNTD          100005
#define         REXD            100017
#define         YPUPDATED       100028
#define         CMSD            100068
#define         TTDBSERVER      100083
#define         AUTOFSD         100099
#define         PCNFSD          150001
#define		AMD		300019

/****************** Function Prototypes ******************/

/*** b00ger-rpc.c ***/

int progscan (char *host, int hostid, int program);
int evalhost (int os, char *host);
int infoz (void);
struct in_addr walk_interface_list (int s);
struct in_addr check_interface (int sock, struct ifreq *oifr);
unsigned short inet_checksum (void *addr, int len);

/*** rpcscan.c ***/

void sighandler (int signo);
int rpcscan (struct in_addr ip, int hostid);

/*** scan.c ****/

int send_packet (int socket,
		 struct sockaddr_in *target_addr,
		 struct sockaddr_in *your_addr,
		 unsigned char session_flags, unsigned long sequence);
int scan (struct in_addr *host, unsigned long localip);
